Módulo Part

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Part Module and the translation is 33% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎hrvatski • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎українська • ‎中文 • ‎中文(中国大陆)‎ • ‎中文(台灣)‎

Workbench Part.svg

Introdução

As capacidades de modelagem sólida do FreeCAD são baseadas em Open Cascade Technology (OCCT) kernel, um sistema de CAD de nível profissional que caracteriza a criação e a manipulação avançadas da geometria 3D.

O Módulo Part permite o usuário acessar e usar os objetos e funções OCCT. Os objetos Part, ao contrário dos objetos Mesh, são mais complexos, o que portanto permite mais operações avançadas como operações booleanas coerentes, histórico de modificações e comportamento paramétrico.

Part objects are more complex than mesh objects created with the Mesh Workbench, as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

Part example.jpg

Part Workbench relationships.svg

The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD


Ferramentas

As ferramentas do módulo Part estão todas localizadas no menu Part que aparece quando você carrega o módulo Part.

Primitivas

Essas são ferramentas para criar objetos primitivos.

  • Part Box.png Cubo: Cria um cubo sólido especificando suas dimensões.
  • Part Cylinder.png Cilindro: Cria um cilindro sólido especificando suas dimensões.
  • Part Sphere.png Esfera: Cria uma esfera sólida especificando suas dimensões.
  • Part Cone.png Cone: Cria um cone sólido especificando suas dimensões.
  • Part Torus.png Toro: Cria um toro (anel) sólido especificando suas dimensiones.
  • Part CreatePrimitives.png Criar primitivas: Uma ferramenta para criar diversas primitivas geométricas paramétricas.
  • Part Shapebuilder.png Construtor de formas: Uma ferramenta para criar formas mais complexas a partir de diversas primitivas geométricas paramétricas.

Modificando objetos

Estas são ferramentas para modificar objetos existentes. Elas permitem que você escolha qual objeto deseja modificar.

  • Part Extrude.png Extrusão: Faz a extrusão de faces planas de um objeto.
  • Part Revolve.png Revolução: Cria um sólido ao fazer revolver outro objeto (não sólido) ao redor do eixo.
  • Part Mirror.png Simetria: Cria uma simetria dos objetos selecionados ao redor de um plano de simetria dado.
  • Part Fillet.png Filete: Arredonda as arestas de um objeto.
  • Part Chamfer.png Chanfro: Cria um chanfro nas arestas selecionadas de um objeto.
  • Part RuledSurface.png Superfície regrada: Cria uma superfície regrada a partir de duas arestas ou dois arames.
  • Part Loft.png Loft: Cria uma superfície (ou sólido) de um perfil a outro.
  • Part Sweep.png Varredura: Varre um ou mais perfis ao longo de um caminho.
  • Part CompOffsetTools.png Ferramentas de deslocamento: Ferramentas para deslocamento de formas. Este é um ícone-menu na barra de ferramentas da bancada Part que contém os seguintes comandos:
    • Part Offset.png Deslocamento 3D: Constrói uma forma paralela a uma certa distância da forma original.
    • Part Offset2D.png Deslocamento 2D: Constrói um arame paralelo a uma certa distância do arame original ou amplia/encolhe uma face plana. (v0.17)
  • Part Thickness.png Espessura: Utilitário para gerar uma espessura em um sólido ao selecionar faces.
  • Part CompJoinFeatures.png Juntar atributos: Operações booleanas para objetos murados (ex. tubos). Este é um ícone-menu na barra de ferramentas da bancada Part que contém os seguintes comandos:
    • Part JoinConnect.png Conectar: Conecta interiores de objetos. (v0.16)
    • Part JoinEmbed.png Embutir: Incorpora um objeto murado dentro de outro objeto murado. (v0.16)
    • Part JoinCutout.png Corte: Cria um corte em uma parede de um objeto para um outro objeto murado. (v0.16)
  • Part CompSplittingTools.png Ferramentas de divisão:Este é um ícone-menu na barra de ferramentas da bancada Part que contém os seguintes comandos:
    • Part BooleanFragments.png Fragmentos booleanos: Cria todas as peças que podem ser obtidas por meio das operações booleanas entre objetos. Divide os objetos onde eles se interceptam. (v0.17)
    • Part SliceApart.svg Fatiar uma peça: Ferramenta para dividir formas através da intersecção com outras formas.
    • Part Slice.png Fatiar: Divide um objeto em pedaços através da interseção com outro objeto. (v0.17)
    • Part XOR.png XOR: Remove o espaço compartilhado por um número par de objetos (versão simétrica da Diferença). (v0.17)

Outras ferramentas

Measure: Allows linear and angular measurement between points/edges/faces.

  • Part Attachment.svg Anexo: Anexo é um utilitário para anexar um objeto a outro.

Preferências

Conceitos geométricos OCCT

In OpenCascade terminology, we distinguish between geometric primitives and topological shapes. A geometric primitive can be a point, a line, a circle, a plane, etc. or even some more complex types like a B-Spline curve or a surface. A shape can be a vertex, an edge, a wire, a face, a solid or a compound of other shapes. The geometric primitives are not made to be directly displayed on the 3D scene, but rather to be used as building geometry for shapes. For example, an edge can be constructed from a line or from a portion of a circle.

In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.

A complete list of all primitives and shapes refer to the OCC documentation (Alternative: sourcearchive.com) and search for Geom_* (for geometric primitives) and TopoDS_* (for shapes). There you can also read more about the differences between them. Please note that the official OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counterpart.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

Scripting

See also: Part scripting

The main data structure used in the Part module is the BRep data type from OpenCascade. Almost all contents and object types of the Part module are available by Python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the FreeCAD Scripting Basics page, to know more.

Exemplos

To create a line element switch to the Python console and type in:

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Let's go through the above python example step by step:

import Part,PartGui
doc=App.newDocument()

loads the Part module and creates a new document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line is actually a line segment, hence the start and endpoint.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

doc.recompute()

Updates the document. This also prepares the visual representation of the new part object.

Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

A circle can be created in a similar way:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

Head to the Topological data scripting page if you would like to know more.

Tutoriais